Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_ubs.F90	(revision 2528)
@@ -544,5 +350,4 @@
          END DO
       END DO
-
       ! monotonic flux in the k direction, i.e. pcc
       ! -------------------------------------------
@@ -550,5 +355,4 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-
                za = MIN( 1., zbetdo(ji,jj,jk), zbetup(ji,jj,jk-1) )
                zb = MIN( 1., zbetup(ji,jj,jk), zbetdo(ji,jj,jk-1) )
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbc.F90	(revision 2528)
@@ -2,22 +2,22 @@
    !!==============================================================================
    !!                       ***  MODULE  trabbc  ***
-   !! Ocean active tracers:  bottom boundary condition
+   !! Ocean active tracers:  bottom boundary condition (geothermal heat flux)
    !!==============================================================================
-   !! History :  8.1  ! 99-10 (G. Madec)  original code
-   !!            8.5  ! 02-08 (G. Madec)  free form + modules
-   !!            8.5  ! 02-11 (A. Bozec)  tra_bbc_init: original code
+   !! History :  OPA  ! 1999-10 (G. Madec)  original code
+   !!   NEMO     1.0  ! 2002-08 (G. Madec)  free form + modules
+   !!             -   ! 2002-11 (A. Bozec)  tra_bbc_init: original code
+   !!            3.3  ! 2010-10 (G. Madec)  dynamical allocation + suppression of key_trabbc
+   !!             -   ! 2010-11 (G. Madec)  use mbkt array (deepest ocean t-level)
    !!----------------------------------------------------------------------
-#if   defined key_trabbc   ||   defined key_esopa
-   !!----------------------------------------------------------------------
-   !!   'key_trabbc'                                  geothermal heat flux
+
    !!----------------------------------------------------------------------
    !!   tra_bbc      : update the tracer trend at ocean bottom 
    !!   tra_bbc_init : initialization of geothermal heat flux trend
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and active tracers
-   USE dom_oce         ! ocean space and time domain
+   USE oce             ! ocean variables
+   USE dom_oce         ! domain: ocean
    USE phycst          ! physical constants
-   USE trdmod          ! ocean trends 
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! trends: ocean variables 
+   USE trdtra          ! trends: active tracers 
    USE in_out_manager  ! I/O manager
    USE prtctl          ! Print control
@@ -27,23 +27,20 @@
 
    PUBLIC tra_bbc          ! routine called by step.F90
+   PUBLIC tra_bbc_init     ! routine called by opa.F90
 
-   !! to be transfert in the namelist ???!   
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbc = .TRUE.   !: bbc flag
+   !                                                !!* Namelist nambbc: bottom boundary condition *
+   LOGICAL, PUBLIC ::   ln_trabbc     = .FALSE.      !: Geothermal heat flux flag
+   INTEGER         ::   nn_geoflx     = 1            !  Geothermal flux (=1:constant flux, =2:read in file )
+   REAL(wp)        ::   rn_geoflx_cst = 86.4e-3_wp   !  Constant value of geothermal heat flux
 
-   !                                         !!* Namelist nambbc: bottom boundary condition *
-   INTEGER  ::   nn_geoflx     = 1            ! Geothermal flux (0:no flux, 1:constant flux, 2:read in file )
-   REAL(wp) ::   rn_geoflx_cst = 86.4e-3      ! Constant value of geothermal heat flux
-
-   INTEGER , DIMENSION(jpi,jpj) ::   nbotlevt   ! ocean bottom level index at T-pt
-   REAL(wp), DIMENSION(jpi,jpj) ::   qgh_trd0   ! geothermal heating trend
+   REAL(wp), PUBLIC, DIMENSION(:,:), ALLOCATABLE ::   qgh_trd0   ! geothermal heating trend
  
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -61,5 +58,5 @@
       !!       ocean bottom can be computed once and is added to the temperature
       !!       trend juste above the bottom at each time step:
-      !!            ta = ta + Qsf / (rau0 rcp e3T) for k= mbathy -1
+      !!            ta = ta + Qsf / (rau0 rcp e3T) for k= mbkt
       !!       Where Qsf is the geothermal heat flux.
       !!
@@ -70,44 +67,36 @@
       !!              Emile-Geay and Madec, 2009, Ocean Science.
       !!----------------------------------------------------------------------
-      USE oce, ONLY :   ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :   ztrds => va   ! use va as 3D workspace   
-      !!
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      INTEGER  ::   ji, jj    ! dummy loop indices
-      REAL(wp) ::   zqgh_trd  ! geothermal heat flux trend
+      INTEGER  ::   ji, jj, ik    ! dummy loop indices
+      REAL(wp) ::   zqgh_trd      ! geothermal heat flux trend
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt
       !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL tra_bbc_init      ! Initialization
-
+      !
       IF( l_trdtra )   THEN         ! Save ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = 0.e0
-      ENDIF
-
-      ! Add the geothermal heat flux trend on temperature
-
-      SELECT CASE ( nn_geoflx )
-      !
-      CASE ( 1:2 )                !  geothermal heat flux
-#if defined key_vectopt_loop
-         DO jj = 1, 1
-            DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
-#else
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
-#endif
-               zqgh_trd = ro0cpr * qgh_trd0(ji,jj) / fse3t(ji,jj,nbotlevt(ji,jj))
-               ta(ji,jj,nbotlevt(ji,jj)) = ta(ji,jj,nbotlevt(ji,jj)) + zqgh_trd
-            END DO
-         END DO
-      END SELECT
-
-      IF( l_trdtra ) THEN        ! Save the geothermal heat flux trend for diagnostics
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_bbc, 'TRA', kt )
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )     ;   ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
       ENDIF
       !
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' bbc  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
+      !                             !  Add the geothermal heat flux trend on temperature
+#if defined key_vectopt_loop
+      DO jj = 1, 1
+         DO ji = jpi+2, jpij-jpi-1   ! vector opt. (forced unrolling)
+#else
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+#endif
+            ik = mbkt(ji,jj)
+            zqgh_trd = qgh_trd0(ji,jj) / fse3t(ji,jj,ik)
+            tsa(ji,jj,ik,jp_tem) = tsa(ji,jj,ik,jp_tem) + zqgh_trd
+         END DO
+      END DO
+      !
+      IF( l_trdtra ) THEN        ! Save the geothermal heat flux trend for diagnostics
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_bbc, ztrdt )
+         DEALLOCATE( ztrdt )
+      ENDIF
+      !
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' bbc  - Ta: ', mask1=tmask, clinfo3='tra-ta' )
       !
    END SUBROUTINE tra_bbc
@@ -128,5 +117,4 @@
       !!
       !! ** Action  : - read/fix the geothermal heat qgh_trd0
-      !!              - compute the bottom ocean level nbotlevt
       !!----------------------------------------------------------------------
       USE iom
@@ -135,64 +123,50 @@
       INTEGER  ::   inum                ! temporary logical unit
       !!
-      NAMELIST/nambbc/nn_geoflx, rn_geoflx_cst 
+      NAMELIST/nambbc/ln_trabbc, nn_geoflx, rn_geoflx_cst 
       !!----------------------------------------------------------------------
 
-      REWIND ( numnam )              ! Read Namelist nambbc : bottom momentum boundary condition
-      READ   ( numnam, nambbc )
+      REWIND( numnam )                 ! Read Namelist nambbc : bottom momentum boundary condition
+      READ  ( numnam, nambbc )
 
-      IF(lwp) THEN                   ! Control print
+      IF(lwp) THEN                     ! Control print
          WRITE(numout,*)
-         WRITE(numout,*) 'tra_bbc : temperature Bottom Boundary Condition (bbc), Geothermal heatflux'
+         WRITE(numout,*) 'tra_bbc : Bottom Boundary Condition (bbc), apply a Geothermal heating'
          WRITE(numout,*) '~~~~~~~   '
          WRITE(numout,*) '   Namelist nambbc : set bbc parameters'
-         WRITE(numout,*) '      Geothermal flux            nn_geoflx     = ', nn_geoflx
-         WRITE(numout,*) '      Constant geothermal flux   rn_geoflx_cst = ', rn_geoflx_cst
+         WRITE(numout,*) '      Apply a geothermal heating at ocean bottom   ln_trabbc     = ', ln_trabbc
+         WRITE(numout,*) '      type of geothermal flux                      nn_geoflx     = ', nn_geoflx
+         WRITE(numout,*) '      Constant geothermal flux value               rn_geoflx_cst = ', rn_geoflx_cst
          WRITE(numout,*)
       ENDIF
 
-      !                              ! level of the ocean bottom at T-point
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            nbotlevt(ji,jj) = MAX( mbathy(ji,jj)-1, 1 )
-         END DO
-      END DO
-
-      SELECT CASE ( nn_geoflx )      ! initialization of geothermal heat flux
-      !
-      CASE ( 0 )                ! no geothermal heat flux
+      IF( ln_trabbc ) THEN             !==  geothermal heating  ==!
+         !
+         ALLOCATE( qgh_trd0(jpi,jpj) )    ! allocation
+         !
+         SELECT CASE ( nn_geoflx )        ! geothermal heat flux / (rauO * Cp)
+         !
+         CASE ( 1 )                          !* constant flux
+            IF(lwp) WRITE(numout,*) '      *** constant heat flux  =   ', rn_geoflx_cst
+            qgh_trd0(:,:) = ro0cpr * rn_geoflx_cst
+            !
+         CASE ( 2 )                          !* variable geothermal heat flux : read the geothermal fluxes in mW/m2
+            IF(lwp) WRITE(numout,*) '      *** variable geothermal heat flux'
+            CALL iom_open ( 'geothermal_heating.nc', inum )
+            CALL iom_get  ( inum, jpdom_data, 'heatflow', qgh_trd0 )
+            CALL iom_close( inum )
+            qgh_trd0(:,:) = ro0cpr * qgh_trd0(:,:) * 1.e-3     ! conversion in W/m2
+            !
+         CASE DEFAULT
+            WRITE(ctmp1,*) '     bad flag value for nn_geoflx = ', nn_geoflx
+            CALL ctl_stop( ctmp1 )
+            !
+         END SELECT
+         !
+      ELSE
          IF(lwp) WRITE(numout,*) '      *** no geothermal heat flux'
-         !
-      CASE ( 1 )                ! constant flux
-         IF(lwp) WRITE(numout,*) '      *** constant heat flux  =   ', rn_geoflx_cst
-         !
-         qgh_trd0(:,:) = rn_geoflx_cst
-         !
-      CASE ( 2 )                ! variable geothermal heat flux : read the geothermal fluxes in mW/m2
-         IF(lwp) WRITE(numout,*) '      *** variable geothermal heat flux'
-         CALL iom_open ( 'geothermal_heating.nc', inum )
-         CALL iom_get  ( inum, jpdom_data, 'heatflow', qgh_trd0 )
-         CALL iom_close( inum )
-         !
-         qgh_trd0(:,:) = qgh_trd0(:,:) * 1.e-3 ! conversion in W/m2
-         !
-      CASE DEFAULT
-         WRITE(ctmp1,*) '     bad flag value for nn_geoflx = ', nn_geoflx
-         CALL ctl_stop( ctmp1 )
-         !
-      END SELECT
+      ENDIF
       !
    END SUBROUTINE tra_bbc_init
 
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option                                         Empty module
-   !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbc = .FALSE.  !: bbc flag
-CONTAINS
-   SUBROUTINE tra_bbc( kt )           ! Empty routine
-      WRITE(*,*) 'tra_bbc: You should not have seen this print! error?', kt
-   END SUBROUTINE tra_bbc
-#endif
-
    !!======================================================================
 END MODULE trabbc
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/trabbl.F90	(revision 2528)
@@ -4,54 +4,62 @@
    !! Ocean physics :  advective and/or diffusive bottom boundary layer scheme
    !!==============================================================================
-   !! History :  8.0  !  96-06  (L. Mortier)  Original code
-   !!            8.0  !  97-11  (G. Madec)  Optimization
-   !!            8.5  !  02-08  (G. Madec)  free form + modules
-   !!----------------------------------------------------------------------
-#if   defined key_trabbl_dif   ||   defined key_trabbl_adv   || defined key_esopa
-   !!----------------------------------------------------------------------
-   !!   'key_trabbl_dif'   or            diffusive bottom boundary layer
-   !!   'key_trabbl_adv'                 advective bottom boundary layer
-   !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!   tra_bbl_dif  : update the active tracer trends due to the bottom
-   !!                  boundary layer (diffusive only)
-   !!   tra_bbl_adv  : update the active tracer trends due to the bottom
-   !!                  boundary layer (advective and/or diffusive)
-   !!   tra_bbl_init : initialization, namlist read, parameters control
-   !!----------------------------------------------------------------------
-   USE oce                ! ocean dynamics and active tracers
-   USE dom_oce            ! ocean space and time domain
-   USE trdmod             ! ocean active tracers trends
-   USE trdmod_oce         ! ocean variables trends
-   USE in_out_manager     ! I/O manager
-   USE lbclnk             ! ocean lateral boundary conditions
-   USE prtctl             ! Print control
+   !! History :  OPA  ! 1996-06  (L. Mortier)  Original code
+   !!            8.0  ! 1997-11  (G. Madec)    Optimization
+   !!   NEMO     1.0  ! 2002-08  (G. Madec)  free form + modules
+   !!             -   ! 2004-01  (A. de Miranda, G. Madec, J.M. Molines ) add advective bbl
+   !!            3.3  ! 2009-11  (G. Madec)  merge trabbl and trabbl_adv + style + optimization 
+   !!             -   ! 2010-04  (G. Madec)  Campin & Goosse advective bbl 
+   !!             -   ! 2010-06  (C. Ethe, G. Madec)  merge TRA-TRC
+   !!             -   ! 2010-11  (G. Madec) add mbk. arrays associated to the deepest ocean level
+   !!----------------------------------------------------------------------
+#if   defined key_trabbl   ||   defined key_esopa
+   !!----------------------------------------------------------------------
+   !!   'key_trabbl'   or                             bottom boundary layer
+   !!----------------------------------------------------------------------
+   !!   tra_bbl       : update the tracer trends due to the bottom boundary layer (advective and/or diffusive)
+   !!   tra_bbl_dif   : generic routine to compute bbl diffusive trend
+   !!   tra_bbl_adv   : generic routine to compute bbl advective trend
+   !!   bbl           : computation of bbl diffu. flux coef. & transport in bottom boundary layer
+   !!   tra_bbl_init  : initialization, namelist read, parameters control
+   !!----------------------------------------------------------------------
+   USE oce            ! ocean dynamics and active tracers
+   USE dom_oce        ! ocean space and time domain
+   USE phycst         ! physical constant
+   USE eosbn2         ! equation of state
+   USE trdmod_oce     ! trends: ocean variables
+   USE trdtra         ! trends: active tracers
+   USE iom            ! IOM server               
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! ocean lateral boundary conditions
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC tra_bbl_dif    ! routine called by step.F90
-   PUBLIC tra_bbl_adv    ! routine called by step.F90
-
-   !!* Namelist nambbl: bottom boundary layer
-   REAL(wp), PUBLIC ::   rn_ahtbbl = 1.e+3   !: lateral coeff. for bottom boundary layer scheme (m2/s)
-
-# if defined key_trabbl_dif
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_dif = .TRUE.          !: diffusive bottom boundary layer flag
-# else
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_dif = .FALSE.         !: diffusive bottom boundary layer flag
-# endif
-
-# if defined key_trabbl_adv
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_adv = .TRUE.   !: advective bottom boundary layer flag
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   u_bbl      !: 3 components of the velocity
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   v_bbl      !: associated with advective BBL
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   w_bbl      !: (only affect tracer)
-# else
-   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl_adv = .FALSE.  !: advective bottom boundary layer flag
-# endif
-
-   INTEGER, DIMENSION(jpi,jpj) ::   mbkt          ! vertical index of the bottom ocean T-level
-   INTEGER, DIMENSION(jpi,jpj) ::   mbku, mbkv    ! vertical index of the bottom ocean U/V-level
+   PUBLIC   tra_bbl       !  routine called by step.F90
+   PUBLIC   tra_bbl_init  !  routine called by opa.F90
+   PUBLIC   tra_bbl_dif   !  routine called by trcbbl.F90
+   PUBLIC   tra_bbl_adv   !  -          -          -              -
+   PUBLIC   bbl           !  routine called by trcbbl.F90 and dtadyn.F90
+
+   LOGICAL, PUBLIC, PARAMETER ::   lk_trabbl = .TRUE.    !: bottom boundary layer flag
+
+   !                                           !!* Namelist nambbl * 
+   INTEGER , PUBLIC ::   nn_bbl_ldf = 0         !: =1   : diffusive bbl or not (=0)
+   INTEGER , PUBLIC ::   nn_bbl_adv = 0         !: =1/2 : advective bbl or not (=0)
+   !                                            !  =1 : advective bbl using the bottom ocean velocity
+   !                                            !  =2 :     -      -  using utr_bbl proportional to grad(rho)
+   REAL(wp), PUBLIC ::   rn_ahtbbl  = 1.e3_wp   !: along slope bbl diffusive coefficient [m2/s]
+   REAL(wp), PUBLIC ::   rn_gambbl  = 10.0_wp   !: lateral coeff. for bottom boundary layer scheme [s]
+
+   REAL(wp), DIMENSION(jpi,jpj), PUBLIC ::   utr_bbl  , vtr_bbl   ! u- (v-) transport in the bottom boundary layer
+   REAL(wp), DIMENSION(jpi,jpj), PUBLIC ::   ahu_bbl  , ahv_bbl   ! masked diffusive bbl coefficients at u and v-points
+
+   INTEGER , DIMENSION(jpi,jpj) ::   mbku_d   , mbkv_d      ! vertical index of the "lower" bottom ocean U/V-level
+   INTEGER , DIMENSION(jpi,jpj) ::   mgrhu    , mgrhv       ! = +/-1, sign of grad(H) in u-(v-)direction
+   REAL(wp), DIMENSION(jpi,jpj) ::   ahu_bbl_0, ahv_bbl_0   ! diffusive bbl flux coefficients at u and v-points
+   REAL(wp), DIMENSION(jpi,jpj) ::   e3u_bbl_0, e3v_bbl_0   ! thichness of the bbl (e3) at u and v-points
+   REAL(wp), DIMENSION(jpi,jpj) ::   e1e2t_r   ! thichness of the bbl (e3) at u and v-points
+   LOGICAL, PUBLIC              ::   l_bbl                    !: flag to compute bbl diffu. flux coef and transport
 
    !! * Substitutions
